#!/bin/bash

# generate macros for MIDI
microabc -i31et.txt -o31et-midi.abh

# generate macros for score using no-dumb (defacc) accidentals
microabc -i31et.txt aliasabc:0 replaceabc:0\ noaccid -o31et-d0 dumbacc:-1
microabc -i31et.txt aliasabc:1 replaceabc:1\ noaccid -o31et-d1 dumbacc:0
cat 31et-d0 31et-d1 > 31et-ps-noaccid.abh

# generate macros for score using accidentals in each note (dumb)
microabc -i31et.txt aliasabc:0 replaceabc:0 -o31et-d0 dumbacc:1
microabc -i31et.txt aliasabc:1 replaceabc:1 -o31et-d1 dumbacc:0
cat 31et-d0 31et-d1 > 31et-ps.abh
rm -f 31et-d0 31et-d1

# preprocess
cat 31et-midi.abh 31et.abp | abcpp > 31et-midi.abc
cat 31et-ps-noaccid.abh 31et.abp | abcpp > 31et-ps-noaccid.abc
cat 31et-ps.abh 31et.abp | abcpp > 31et-ps.abc

# make
abcm2ps -O= 31et-ps-noaccid.abc
abcm2ps -O= 31et-ps.abc
abc2midi 31et-midi.abc



