/* Copyright (C) 2006 Hudson Lacerda
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

int et(int n, double m);
double interv2cents(double interv);
double scl2cents(char *s);
double cents2interv(double cents);

int flag=0;

int main(int argc, char *argv[])
{
    int n=12;
    double m=2.0;
    if(argc>1)
	n=atoi(argv[1]);
    if(argc>2)
	m=cents2interv(scl2cents(argv[2]));
    if(argc>3)
	flag=1;
    et(n,m);
}

int et(int n, double m)
{
    int i;
    for(i=0; i<=n; i++) {
	if(flag==0)
	    fprintf(stdout,"%3d: ",i);
	fprintf(stdout,"%12.6lf  \n",
		interv2cents(pow(m,(double)i/(double)n)));
    }
}

double interv2cents(double interv)
{
    return 1200.0 * (log(interv)/log(2.0));
}

double scl2cents(char *s) /* TODO: check-up */
{
    double n=0.0, d=1.0;
    int c;
    if(c=sscanf(s, "%lf/%lf\n",&n,&d))
	if(c==1 && strchr(s,'.')!=NULL)
	    return n;
    return interv2cents(n/d);
}

double cents2interv(double cents)
{
    return pow(2.0,cents/1200.0);
}
